/***
BEGIN LICENSE
Copyright (C) 2011 Cody Garver <codygarver@gmail.com>
This program is free software: you can redistribute it and/or modify it 
under the terms of the GNU Lesser General Public License version 3, as published 
by the Free Software Foundation.
 
This program is distributed in the hope that it will be useful, but 
WITHOUT ANY WARRANTY; without even the implied warranties of 
MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR 
PURPOSE.  See the GNU General Public License for more details.
 
You should have received a copy of the GNU General Public License along 
with this program.  If not, see <http://www.gnu.org/licenses/>.
END LICENSE
***/

using Gtk;
using ElementaryWidgets;
//include Info.vala window
//using InfoWidget;

namespace Absolem {

public const string VERSION = "0.1";
public const int MAIN_MIN_WIDTH = 500;
public const int MAIN_MIN_HEIGHT = 450;

/*public const int INFO_MIN_WIDTH = 280;
public const int INFO_MIN_HEIGHT = 320;*/

// kill absolem on exit
public void destroy_handler () {
        
        Gtk.main_quit ();
    
    }

public class AbsolemWindow : Window {

 	// toolbar widgets
        private AppMenu app_menu;
        private Toolbar toolbar;
	private ToolItem lspace = new ToolItem ();
        private ToolItem rspace = new ToolItem ();
	private ToolButton save_map_as_image = new ToolButton.from_stock (Stock.SAVE);
	private ToolButton perform_scan = new ToolButton.from_stock (Stock.REFRESH);

	// spinner for when a scan is running
	private Gtk.Spinner scanning_spinner = new Gtk.Spinner();

	// content area widgets
        private VBox vbox;

    	public AbsolemWindow () {

	title ="Absolem";

	icon_name = "absolem";

	// kill the program on exit
	destroy.connect(destroy_handler);

	set_size_request(MAIN_MIN_WIDTH, MAIN_MIN_HEIGHT);

	/* either gtk3 or cmake doesn't like this
	this.position = Gtk.WindowPosition.CENTER;*/

	// I wish this worked. Trying to set app background to white
	/*var color = Gdk.Color ();
        Gdk.Color.parse ("#fff", out color);
	this.modify_base (Gtk.StateType.NORMAL, color);*/
        /*category_plugs.modify_base (Gtk.StateType.NORMAL, color);*/

        // setup toolbar
        setup_toolbar ();

	// create the interface
        this.vbox = new VBox (false, 0);

        this.vbox.pack_start (this.toolbar, false, false);

        this.add (this.vbox);

        this.vbox.show();

        this.show();
	
	// run initial scan to populate the map
	// disable for development purposes
	// nmap_scan();

	}  


        private void setup_toolbar () {

            // global toolbar widgets
            this.toolbar = new Toolbar ();

            var menu = new Menu ();

            this.app_menu = new AppMenu (this, menu, "Absolem",
                                        "absolem",
                                        "http://launchpad.net/absolem",
                                        "0.1",
                                        "Copyright © 2011 Cody Garver",
                                        {"Cody Garver <codygarver@gmail.com>"},
                                        "preferences-system-network");
            // spacing
            this.lspace.set_expand (true);

            this.rspace.set_expand (true);

	    // disable the export-as-image button until it works
	    this.save_map_as_image.sensitive = false;

	    // this is the temporary scan button
	    this.perform_scan.sensitive = true;

            // Add things to the toolbar
            // this.toolbar.insert (navigation_button, 0);
	    this.toolbar.insert (this.perform_scan, 0);
	    this.toolbar.insert (this.save_map_as_image, 1);

            this.toolbar.insert (this.lspace, 2);
            // this.toolbar.insert (this.progress_toolitem, 2);

            this.toolbar.insert (this.rspace, 3);
            // this.toolbar.insert (find_toolitem, 4);

            this.toolbar.insert (this.app_menu, 4);

            this.toolbar.show_all();

	    perform_scan.clicked.connect (nmap_scan);

	    save_map_as_image.clicked.connect (save_map);

        }

	private void save_map () {

		stdout.printf("Exporting not yet available.\n");

	}
}

AbsolemWindow app;

/*public class InfoWindow : Gtk.Dialog {

        private VBox vbox;

	public InfoWindow () {

	// content area widgets

	title ="Info";

	// kill the program on exit
	destroy.connect(destroy_handler);

	set_size_request(INFO_MIN_WIDTH, INFO_MIN_HEIGHT);

	this.position = Gtk.DialogPosition.CENTER;

	// create the interface
        this.vbox = new VBox (false, 0);

        //this.vbox.pack_start (this.toolbar, false, false);

        this.add (this.vbox);

        this.vbox.show();

        this.show();


	}    
}*/

// This is where we tell the application the main action(s) to perform. Draw the gui.   
public void main (string[] args) {

    Gtk.init (ref args);

            app = new AbsolemWindow ();

	    app.show_all ();

        Gtk.main ();
    }

}
